import { ServiceAccountCredentials } from 'google-spreadsheet';

type BotConfig<Details> = {
  name: string;
  id: string;
  token: string;
  details: Details;
};

type BardDetails = {
  channelIds: {
    dedicated: string;
    control: string;
  };
  sheetIds: {
    phrases: string;
    stems: string;
  };
  clueHeader: string;
};

type StemswardenDetails = {
  channelIds: {
    dedicated: string;
    control: string;
  };
  sheetIds: {
    phrases: string;
    stems: string;
  };
  guessHeader: string;
  responseHeader: string;
};

type OrdermasterDetails = {
  channelIds: {
    dedicated: string;
    control: string;
  };
  sheetIds: {
    phrases: string;
    stems: string;
  };
  guessHeader: string;
  responseHeader: string;
};

type NoteyDetails = {
  channelIds: {
    dedicated: string;
    control: string;
  };
};

type DissonatorDetails = never;

type GlobalConfig = {
  spreadsheetId: string;
  googleAuth: ServiceAccountCredentials;
  generalChannelId: string;
  bots: {
    bard: BotConfig<BardDetails>;
    stemswarden: BotConfig<StemswardenDetails>;
    ordermaster: BotConfig<OrdermasterDetails>;
    notey: BotConfig<NoteyDetails>;
  };
  dissonators: {
    controlChannelId: string;
    phrasesSheetId: string;
    bots: BotConfig<DissonatorDetails>[];
  };
};
